<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, Release 7 of June 14, 2002 on October 21, 2002 at 3:41:40 am</time-stamp>


<name-space>
<name>ECEC</name>
<environment>CormasNS.Models</environment>
<private>false</private>
<imports>
			private Smalltalk.*
			private CormasNS.Kernel.*
			</imports>
<category>ECECCategory</category>
</name-space>


<class>
<name>Forager</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Kernel.AgentLocation</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>strategy energy </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.ECEC.Forager</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Forager class</class-id> <category>id</category>

<body>CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body>CurrentId: x
	^CurrentId := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager class</class-id> <category>parameters</category>

<body>fertilityThreshold
	^100</body>

<body>metabolicRate
	^2</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>accessing</category>

<body>energy: aValue
energy := aValue</body>

<body>strategy
^strategy</body>

<body>strategy: aValue
strategy := aValue</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>init</category>

<body>initWithEnergy: aValue strategy: aSymbol
	super init.
	self energy: aValue.
	self strategy: aSymbol</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>control</category>

<body>step
| newForager |
	self updateEnergy.
	self move.
	self eat.
	newForager := self reproduce.
	self die.
	^newForager</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>pov</category>

<body>povStrategy
	^self strategy</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>probes</category>

<body>energy
^energy</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>id</category>

<body>initId
	self id: (self class CurrentId: self class CurrentId + 1)</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Forager</class-id> <category>biology</category>

<body>die
	self energy &lt;= 0 ifTrue: [self dead: true].</body>

<body>eat
| qty |
	qty := self patch energy * self harvestRate.
	self energy: self energy + qty.
	self patch energy: self patch energy - qty</body>

<body>harvestRate
	self strategy = #unrestrained ifTrue: [^0.99].
	self strategy = #restrained ifTrue: [^0.5]</body>

<body>move
	(self patch neighboursMaxOf: #energy) &lt; self class metabolicRate 
		ifTrue: [self randomWalkConstrainedBy: [:c | c noOccupant]]
		ifFalse: [self walkToMaxOf: #energy constrainedBy: [:c | c noOccupant]]</body>

<body>reproduce
| newForager |
	self energy &gt; self class fertilityThreshold
		ifTrue: 
			[newForager := self class new.
			newForager initWithEnergy: 50 strategy: self strategy.
			self energy: self energy - newForager energy.
			newForager moveTo: self nearestEmptyLocation].
	^newForager</body>

<body>updateEnergy
	self energy: self energy - self class metabolicRate</body>
</methods>


<class>
<name>Plant</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Kernel.SpatialEntityElement</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>energy </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
</class>

<shared-variable>
<name>CurrentId</name>
<environment>CormasNS.Models.ECEC.Plant</environment>
<private>false</private>
<constant>false</constant>
<category>As yet unclassified</category>
</shared-variable>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Plant class</class-id> <category>id</category>

<body>CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]</body>

<body>CurrentId: x
	^CurrentId := x</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant class</class-id> <category>parameters</category>

<body>K
	^10</body>

<body>r
	^0.2</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>accessing</category>

<body>energy
^energy</body>

<body>energy: aValue
energy := aValue.
self defineVisualState; show</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>init</category>

<body>init
super init</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>control</category>

<body>step
	self logisticGrowth</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>pov</category>

<body>povFood1C
	^super 
		povAttribute: #energy
		min: 0
		max: self class K
		color: ColorValue green</body>

<body>povFood2C
	^super 
		povAttribute: #energy
		minPalette:#(0 #white)
		maxPalette: #(10 #green)</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>id</category>

<body>initId
	self id: (self class CurrentId: self class CurrentId + 1)</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.Plant</class-id> <category>growth</category>

<body>logisticGrowth
	self energy: self energy + (Cormas
				logisticIncrease: self energy
				r: self class r
				K: self class K)</body>
</methods>


<class>
<name>ECEC</name>
<environment>CormasNS.Models.ECEC</environment>
<super>CormasNS.Kernel.CormasModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>thePlants theForagers </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ECEC Category</category>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.ECEC class</class-id> <category>description</category>

<body>aboutIt
	super 
		makeAboutItDate: '03 October 2002'
		authors: #('Christophe Le Page')
		emails: #('lepage@cirad.fr')
		comments: 'Inspired from a paper by Pepper and Smuts, "Evolution of Cooperation in an Ecological Context"'</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>init</category>

<body>fragmentedEnv
	self spaceModel loadEnvironmentFromFile: 'fragmented.env' withPov: #povFood2C.
	super initCells.
	self initForagers.
	super initData</body>

<body>homogeneousEnv
	self spaceModel loadEnvironmentFromFile: 'random.env' withPov: #povFood2C.
	super initCells.
	self initForagers.
	super initData</body>

<body>noForagers
	self spaceModel loadEnvironmentFromFile: 'poor.env' withPov: #povFood2C.
	super initCells.
	super initAgents.
	super initData</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>control</category>

<body>step: t 
"Resource dynamics"
	super stepEntities: self thePlants.
"Agents dynamics"
	super stepDynPop: self theForagers.
"Probes recording"
	super updateData: t</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>entities creation</category>

<body>initForagers
	super initAgents.
	self 
		setRandomlyLocatedAloneAgents: Forager
		n: 10
		initMethod: #initWithEnergy:strategy:
		arguments: #(50 #restrained).
	self 
		setRandomlyLocatedAloneAgents: Forager
		n: 10
		initMethod: #initWithEnergy:strategy:
		arguments: #(50 #unrestrained)</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>probes</category>

<body>plantEnergy
"return the data (a number) to be plotted with the plantEnergy chart"
^self thePlants inject: 0 into: [:i :j | i + j energy]</body>

<body>restrained
"return the data (a number) to be plotted with the restrained chart"
	^(self theForagers select: [:f | f strategy = #restrained]) size</body>

<body>unrestrained
"return the data (a number) to be plotted with the unrestrained chart"
	^(self theForagers select: [:f | f strategy = #unrestrained]) size</body>
</methods>

<methods>
<class-id>CormasNS.Models.ECEC.ECEC</class-id> <category>accessing</category>

<body>theForagers
^theForagers</body>

<body>theForagers: x
theForagers := x</body>

<body>thePlants
^thePlants</body>

<body>thePlants: x
thePlants := x</body>
</methods>



</st-source>
