'From VisualWorks® NonCommercial, Release 7 of June 14, 2002 on August 19, 2002 at 7:27:33 am'!


CormasNS.Models defineNameSpace: #MyFirstCormasModel
	private: false
	imports: '
			private Smalltalk.*
			private CormasNS.Kernel.*
			'
	category: 'MyFirstCormasModelCategory'!


CormasNS.Models.MyFirstCormasModel defineClass: #Forager
	superclass: #{CormasNS.Kernel.AgentLocation}
	indexedType: #none
	private: false
	instanceVariableNames: 'strategy energy '
	classInstanceVariableNames: 'fertilityThreshold metabolicRate '
	imports: ''
	category: 'MyFirstCormasModel Category'!

CormasNS.Models.MyFirstCormasModel.Forager defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.MyFirstCormasModel.Forager class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

!CormasNS.Models.MyFirstCormasModel.Forager class methodsFor: 'accessing'!

fertilityThreshold
	"Getter accessor with default value = 100 "
fertilityThreshold isNil ifTrue:[fertilityThreshold := 100]. 

	^fertilityThreshold!

fertilityThreshold: anObject
	fertilityThreshold := anObject!

metabolicRate
	"Getter accessor with default value = 2 "
metabolicRate isNil ifTrue:[metabolicRate := 2]. 

	^metabolicRate!

metabolicRate: anObject
	metabolicRate := anObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.MyFirstCormasModel.Forager methodsFor: 'accessing'!

energy: aValue
energy := aValue!

strategy
^strategy!

strategy: aValue
strategy := aValue! !

!CormasNS.Models.MyFirstCormasModel.Forager methodsFor: 'control'!

step
| newForager |
	self updateEnergy.
	self move.
	self eat.
	newForager := self reproduce.
	self die.
	^newForager! !

!CormasNS.Models.MyFirstCormasModel.Forager methodsFor: 'pov'!

povStrategy
	^self strategy! !

!CormasNS.Models.MyFirstCormasModel.Forager methodsFor: 'id'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.MyFirstCormasModel.Forager methodsFor: 'biology'!

die
	self energy <= 0 ifTrue: [self dead: true].!

eat
| qty |
	qty := self patch energy * self harvestRate.
	self energy: self energy + qty.
	self patch energy: self patch energy - qty!

harvestRate
	self strategy = #unrestrained ifTrue: [^0.99].
	self strategy = #restrained ifTrue: [^0.5]!

move
	(self patch neighboursMaxOf: #energy) < self class metabolicRate 
		ifTrue: [self randomWalkConstrainedBy: [:c | c noOccupant]]
		ifFalse: [self walkToMaxOf: #energy constrainedBy: [:c | c noOccupant]]!

reproduce
| newForager |
	self energy > self class fertilityThreshold
		ifTrue: 
			[newForager := self class new.
			newForager strategy: self strategy.
			self energy: self energy - newForager energy.
			newForager moveTo: self nearestEmptyLocation].
	^newForager!

updateEnergy
	self energy: self energy - self class metabolicRate! !

!CormasNS.Models.MyFirstCormasModel.Forager methodsFor: 'probes'!

energy
	"Getter accessor with default value = 50 "
energy isNil ifTrue:[energy := 50]. 

	^energy! !


CormasNS.Models.MyFirstCormasModel defineClass: #Plant
	superclass: #{CormasNS.Kernel.SpatialEntityElement}
	indexedType: #none
	private: false
	instanceVariableNames: 'energy '
	classInstanceVariableNames: 'k r '
	imports: ''
	category: 'MyFirstCormasModel Category'!

CormasNS.Models.MyFirstCormasModel.Plant defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.MyFirstCormasModel.Plant class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

!CormasNS.Models.MyFirstCormasModel.Plant class methodsFor: 'accessing'!

k
	"Getter accessor with default value = 10 "
k isNil ifTrue:[k := 10]. 

	^k!

k: anObject
	k := anObject!

r
	"Getter accessor with default value = 0.2 "
r isNil ifTrue:[r := 0.2]. 

	^r!

r: anObject
	r := anObject! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.MyFirstCormasModel.Plant methodsFor: 'accessing'!

energy
	"Getter accessor with default value = 0 "
energy isNil ifTrue:[energy := 0]. 

	^energy!

energy: aValue
energy := aValue.
self defineVisualState; show! !

!CormasNS.Models.MyFirstCormasModel.Plant methodsFor: 'init'!

init
super init! !

!CormasNS.Models.MyFirstCormasModel.Plant methodsFor: 'control'!

step
	self logisticGrowth! !

!CormasNS.Models.MyFirstCormasModel.Plant methodsFor: 'pov'!

povFood1C
	^super 
		povAttribute: #energy
		min: 0
		max: self class K
		color: ColorValue green!

povFood2C
	^super 
		povAttribute: #energy
		minPalette:#(0 #white)
		maxPalette: #(10 #green)! !

!CormasNS.Models.MyFirstCormasModel.Plant methodsFor: 'id'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.MyFirstCormasModel.Plant methodsFor: 'growth'!

logisticGrowth
	self energy: self energy + (Cormas
				logisticIncrease: self energy
				r: self class r
				K: self class k)! !


CormasNS.Models.MyFirstCormasModel defineClass: #MyFirstCormasModel
	superclass: #{CormasNS.Kernel.CormasModel}
	indexedType: #none
	private: false
	instanceVariableNames: 'thePlants theForagers agentsInitialNumber '
	classInstanceVariableNames: ''
	imports: ''
	category: 'MyFirstCormasModel Category'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.MyFirstCormasModel.MyFirstCormasModel class methodsFor: 'description'!

aboutIt
	super 
		makeAboutItDate: '03 October 2002'
		authors: #('Christophe Le Page')
		emails: #('lepage@cirad.fr')
		comments: 'Inspired from a paper by Pepper and Smuts, "Evolution of Cooperation in an Ecological Context"'! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.MyFirstCormasModel.MyFirstCormasModel methodsFor: 'init'!

fragmentedEnv
	self spaceModel loadEnvironmentFromFile: 'fragmented.env' withPov: #povFood2C.
	super initCells.
	self initForagers.!

homogeneousEnv
	self spaceModel loadEnvironmentFromFile: 'random.env' withPov: #povFood2C.
	super initCells.
	self initForagers.!

noForagers
	self spaceModel loadEnvironmentFromFile: 'poor.env' withPov: #povFood2C.
	super initCells.
	super initAgents! !

!CormasNS.Models.MyFirstCormasModel.MyFirstCormasModel methodsFor: 'control'!

step: t 
"Resource dynamics"
	super stepEntities: self thePlants.
"Agents dynamics"
	super stepDynPop: self theForagers! !

!CormasNS.Models.MyFirstCormasModel.MyFirstCormasModel methodsFor: 'entities creation'!

initForagers
"initialize 'agentsInitialNumber' foragers with restrained strategy and 'agentsInitialNumber' foragers with unrestrained strategy"
	super initAgents.
	self setRandomlyLocatedAloneAgents: Forager
		n: self agentsInitialNumber
		initMethod: #strategy:
		arguments: #(#restrained).
	self setRandomlyLocatedAloneAgents: Forager
		n: self agentsInitialNumber
		initMethod: #strategy:
		arguments: #(#unrestrained)! !

!CormasNS.Models.MyFirstCormasModel.MyFirstCormasModel methodsFor: 'probes'!

plantEnergy
"return the data (a number) to be plotted with the plantEnergy chart"
^self thePlants inject: 0 into: [:i :j | i + j energy]!

restrained
"return the data (a number) to be plotted with the restrained chart"
	^(self theForagers select: [:f | f strategy = #restrained]) size!

unrestrained
"return the data (a number) to be plotted with the unrestrained chart"
	^(self theForagers select: [:f | f strategy = #unrestrained]) size! !

!CormasNS.Models.MyFirstCormasModel.MyFirstCormasModel methodsFor: 'accessing'!

agentsInitialNumber
	"Getter accessor with default value = 10 "
agentsInitialNumber isNil ifTrue:[agentsInitialNumber := 10]. 

	^agentsInitialNumber!

agentsInitialNumber: anObject
	agentsInitialNumber := anObject!

theForagers
^theForagers!

theForagers: x
theForagers := x!

thePlants
^thePlants!

thePlants: x
thePlants := x! !


